''*****************************
''*  analog scope w/ Graphics *
''*  (C) 2005 Parallax, Inc.  *
''*****************************

 ' uses pin=12 for TV   

CON
' cope constants below
 'do not touch those below, came w/ graphic driver
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  _stack = ($3000 + $3000 + 100) >> 2   'accomodate display memory and stack
  x_tiles = 16
  y_tiles = 12
  paramcount = 14       
  bitmap_base = $2000
  display_base = $5000
VAR
 ' uses pin=12 for TV 
  word  nx'=220   ' active pixel display
  word  ny'=160
  word  Dnx'=10 'division unit in pxels
  word  Dny'=10
  word  ticL'=5 ' lenght of the tick
  long  u0,u1,v0,v1,Du,Dv ' world coordinates for display
  
'do not touch those below, came w/ graphic driver
  long  tv_status     '0/1/2 = off/visible/invisible           read-only
  long  tv_enable     '0/? = off/on                            write-only
  long  tv_pins       '%ppmmm = pins                           write-only
  long  tv_mode       '%ccinp = chroma,interlace,ntsc/pal,swap write-only
  long  tv_screen     'pointer to screen (words)               write-only
  long  tv_colors     'pointer to colors (longs)               write-only               
  long  tv_hc         'horizontal cells                        write-only
  long  tv_vc         'vertical cells                          write-only
  long  tv_hx         'horizontal cell expansion               write-only
  long  tv_vx         'vertical cell expansion                 write-only
  long  tv_ho         'horizontal offset                       write-only
  long  tv_vo         'vertical offset                         write-only
  long  tv_broadcast  'broadcast frequency (Hz)                write-only
  long  tv_auralcog   'aural fm cog                            write-only

  word  screen[x_tiles * y_tiles]
  long  colors[64]

 
OBJ
  tv    : "tv"
  gr    : "graphics"
pub plot(x,y)|ix,iy
  ix:=Nx*(x-u0)/Du
  iy:=Ny*(y-v0)/Dv
  if ix=>0 and iy=>0
     gr.plot(ix,iy)
pub line(x,y)|ix,iy
  ix:=Nx*(x-u0)/Du
  iy:=Ny*(y-v0)/Dv
  if ix=>0 and iy=>0
     gr.line(ix,iy)
pub clear
   gr.clear
   update 
pub update
     gr.copy(display_base)    
pub world(a,b,c,d)
   u0:=a
   v0:=b
   u1:=c
   v1:=d
   Du:=u1-u0
   Dv:=v1-v0 
pub startPin12(iNx,iNy,iDx,iDy,iTicL)
   Nx:=iNx
   Ny:=iNy
   Dnx:=iDx
   Dny:=iDy
   TicL:=iTicL

   startTvScope

   gr.clear   'clear bitmap  
   drawFrame
   update
 
'===========================================    
PUB startTvScope | i, k ,dx,dy

  'start tv
  longmove(@tv_status, @tvparams, paramcount)
  tv_screen := @screen
  tv_colors := @colors
  tv.start(@tv_status)

  'init colors
  repeat i from 0 to 63
    colors[i] := $00001010 * (i+4) & $F + $2B060C02

  'init tile screen
  repeat dx from 0 to tv_hc - 1
    repeat dy from 0 to tv_vc - 1
      screen[dy * tv_hc + dx] := display_base >> 6 + dy + dx * tv_vc + ((dy & $3F) << 10)
      
  'start and setup graphics
  gr.start
  gr.setup(16, 12, 20, 20, bitmap_base)
     
pub drawFrame  |i  ,numchr,d

    gr.color(2)
  'draw X-axis       
   gr.plot(0,0)       
   gr.line(nx,0)
   repeat i from 0 to nx/Dnx
      d:=i*Dnx
      gr.plot(d,ny)        
      gr.line(d,-TicL)
      
 ''draw Y-axis      
   gr.plot(0,0)       
   gr.line(0,ny)
   repeat i from 0 to ny/Dny
      d:=i*Dny
      gr.plot(nx,d)        
      gr.line(-TicL,d)

  gr.color(1)
     'draw pix map of dog
    gr.pixarc(90,90,0,0,0,0,@pixdef2)

        gr.width(0)

  return

DAT

tvparams                long    0               'status
                        long    1               'enable
                        long    %001_0101       'pins
                        long    %0000           'mode
                        long    0               'screen
                        long    0               'colors
                        long    x_tiles         'hc
                        long    y_tiles         'vc
                        long    10              'hx
                        long    1               'vx
                        long    0               'ho
                        long    0               'vo
                        long    0               'broadcast
                        long    0               'auralcog


'small picure of a dog
pixdef2                 word                            'dog
                        byte    1,4,0,3
                        word    %%20000022
                        word    %%02222222
                        word    %%02222200
                        word    %%02000200